
//   ***************************************************************************
//   **                                                                       **
//   **                          DEMO-Program                                 **
//   **                        for testing of a                               **
//   **                                                                       **
//   **                   Smart Card ToolSet PRO v3.3                         **
//   **                                                                       **
//   **                                                                       **
//   **              Copyright (c) 2005 by Igor V.Kharchenko                  **
//   **                                                                       **
//   ***************************************************************************

unit ActiveX_Main;

interface

uses
  ComObj,
  StdVCL,
  AXCtrls,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, OleServer,
  SCardToolSet_COM_Server_TLB,
  ActnList, OleCtrls, SCardToolSetSERVER_ActiveX_TLB;

Const                        tbl      = #9;
                             dvd      = ' ... ';

type
  TMainForm = class(TForm)
    ComboBox1: TComboBox;
    Label1: TLabel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Button7: TButton;
    TabSheet4: TTabSheet;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Edit1: TEdit;
    Label3: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    Edit3: TEdit;
    Label5: TLabel;
    Edit4: TEdit;
    Label6: TLabel;
    Edit5: TEdit;
    Label7: TLabel;
    Edit6: TEdit;
    Label8: TLabel;
    Edit7: TEdit;
    Label9: TLabel;
    TabSheet5: TTabSheet;
    Edit9: TEdit;
    Label11: TLabel;
    Label10: TLabel;
    Edit8: TEdit;
    Label12: TLabel;
    Edit10: TEdit;
    Label13: TLabel;
    Edit11: TEdit;
    Label14: TLabel;
    Edit12: TEdit;
    Label15: TLabel;
    Edit13: TEdit;
    Button14: TButton;
    Edit14: TEdit;
    Label16: TLabel;
    Button13: TButton;
    Button15: TButton;
    Label17: TLabel;
    Edit15: TEdit;
    Button16: TButton;
    Label18: TLabel;
    Edit16: TEdit;
    Button17: TButton;
    Label19: TLabel;
    Edit17: TEdit;
    Button18: TButton;
    Actions: TActionList;
    ShowApp_act: TAction;
    HideApp_act: TAction;
    ConnectSCARD_act: TAction;
    DisconnectSCARD_act: TAction;
    Reopen_act: TAction;
    GetReaderInfo_act: TAction;
    GetCardInfo_act: TAction;
    GetCardTypeInfo_act: TAction;
    SendAPDU_act: TAction;
    SendCOMMAND_act: TAction;
    ErrorLookup_act: TAction;
    StateLookup_act: TAction;
    SWLookup_act: TAction;
    COSLookup_act: TAction;
    GetReadersList_act: TAction;
    TabSheet6: TTabSheet;
    Button5: TButton;
    Button8: TButton;
    Button6: TButton;
    Label2: TLabel;
    Panel1: TPanel;
    Memo: TMemo;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label20: TLabel;
    SmartCardToolSetSERVER_ActiveX1: TSmartCardToolSetSERVER_ActiveX;
    TabSheet7: TTabSheet;
    PageControl2: TPageControl;
    TabSheet8: TTabSheet;
    MemoPref: TMemo;
    TabSheet9: TTabSheet;
    MemoPrefRes: TMemo;
    PropSet_act: TAction;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ConnectSCARD_actExecute(Sender: TObject);
    procedure DisconnectSCARD_actExecute(Sender: TObject);
    procedure Reopen_actExecute(Sender: TObject);
    procedure GetReaderInfo_actExecute(Sender: TObject);
    procedure GetCardInfo_actExecute(Sender: TObject);
    procedure GetCardTypeInfo_actExecute(Sender: TObject);
    procedure SendAPDU_actExecute(Sender: TObject);
    procedure SendCOMMAND_actExecute(Sender: TObject);
    procedure ErrorLookup_actExecute(Sender: TObject);
    procedure StateLookup_actExecute(Sender: TObject);
    procedure SWLookup_actExecute(Sender: TObject);
    procedure COSLookup_actExecute(Sender: TObject);
    procedure GetReadersList_actExecute(Sender: TObject);
    procedure ShowApp_actUpdate(Sender: TObject);
    procedure HideApp_actUpdate(Sender: TObject);
    procedure ConnectSCARD_actUpdate(Sender: TObject);
    procedure DisconnectSCARD_actUpdate(Sender: TObject);
    procedure GetReadersList_actUpdate(Sender: TObject);
    procedure Reopen_actUpdate(Sender: TObject);
    procedure GetReaderInfo_actUpdate(Sender: TObject);
    procedure GetCardInfo_actUpdate(Sender: TObject);
    procedure GetCardTypeInfo_actUpdate(Sender: TObject);
    procedure SendAPDU_actUpdate(Sender: TObject);
    procedure SendCOMMAND_actUpdate(Sender: TObject);
    procedure ErrorLookup_actUpdate(Sender: TObject);
    procedure StateLookup_actUpdate(Sender: TObject);
    procedure SWLookup_actUpdate(Sender: TObject);
    procedure COSLookup_actUpdate(Sender: TObject);
    procedure SmartCardToolSetSERVER_ActiveX1APDU(Sender: TObject;
      var ReaderName: WideString; var SW1, SW2: Byte; var SW_HEX,
      VerboseSWLookup: WideString);
    procedure SmartCardToolSetSERVER_ActiveX1BeforeConnectingSCARD(
      Sender: TObject);
    procedure SmartCardToolSetSERVER_ActiveX1BeforeDisconnectingSCARD(
      Sender: TObject);
    procedure SmartCardToolSetSERVER_ActiveX1BeforeReadersList(
      Sender: TObject);
    procedure SmartCardToolSetSERVER_ActiveX1CardDetected(Sender: TObject;
      var ReaderName: WideString);
    procedure SmartCardToolSetSERVER_ActiveX1CardReady(Sender: TObject;
      var ReaderName, ATR, Protocol: WideString);
    procedure SmartCardToolSetSERVER_ActiveX1CardType(Sender: TObject;
      var ReaderName, ATR, Protocol, TypeName: WideString);
    procedure SmartCardToolSetSERVER_ActiveX1CardWait(Sender: TObject;
      var ReaderName: WideString);
    procedure SmartCardToolSetSERVER_ActiveX1ConnectedSCARD(
      Sender: TObject);
    procedure SmartCardToolSetSERVER_ActiveX1DisconnectedSCARD(
      Sender: TObject);
    procedure SmartCardToolSetSERVER_ActiveX1ReadersList(Sender: TObject;
      var ReadersNames: WideString);
    procedure SmartCardToolSetSERVER_ActiveX1StateChanged(Sender: TObject;
      var ReaderName, StateHex, VerboseStateLookup: WideString;
      var StateValue: Integer);
    procedure SmartCardToolSetSERVER_ActiveX1_ERROR(Sender: TObject;
      var ErrorSource: WideString; var ErrorValue: Integer;
      var VerboseErrorLookup: WideString);
    procedure SmartCardToolSetSERVER_ActiveX1_ServerApplicationClosed(
      Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PropSet_actUpdate(Sender: TObject);
    procedure PropSet_actExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    v        : variant;
    bStrings : TStringList;


    Opened     : boolean;
    Connected  : boolean;

  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
try
bStrings := TStringList.Create;
Opened:=false;
Connected:=false;
PageControl1.ActivePageIndex:=0;
finally
end;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
try
if bStrings<>nil then bStrings.Destroy;
finally
end;
end;




procedure TMainForm.ConnectSCARD_actExecute(Sender: TObject);
var       jj,vMajor,vMinor,vBuild:integer;
          ProgramTitle:widestring;
          bb:wordbool;
begin
try
  try
  SmartCardToolSetSERVER_ActiveX1.ConnectSCARD;
  Opened:=true;
  Memo.Lines.Add('');
  Memo.Lines.Add('');
  Memo.Lines.Add('Server opened');
  Memo.Lines.Add('');
  ProgramTitle:=SmartCardToolSetSERVER_ActiveX1.About;
  Memo.Lines.Add(dvd+tbl+'Program Title   '+tbl+ProgramTitle);
  Memo.Lines.Add('');

  bb:=SmartCardToolSetSERVER_ActiveX1.IsConnectedSCARD;
  if bb
     then begin
          GetReadersList_act.Execute;
          Memo.Lines.Add('Already connected to MS Smart Card service');
          Connected:=true;
          end
     else begin
          Memo.Lines.Add('Not connected to MS Smart Card service');
          Connected:=false;
          end;



  except  on em:exception do
          begin
          Opened:=false;
          end;
  end;
finally
end;
end;

procedure TMainForm.DisconnectSCARD_actExecute(Sender: TObject);
begin
try
SmartCardToolSetSERVER_ActiveX1.DisconnectSCARD;
finally
end;
end;

procedure TMainForm.Reopen_actExecute(Sender: TObject);
var       ss:widestring;
begin
try
ss:=ComboBox1.Text;
SmartCardToolSetSERVER_ActiveX1.ReOpenReader(ss);
finally
end;
end;

procedure TMainForm.GetReaderInfo_actExecute(Sender: TObject);
var       ww,ss:widestring;
          info:string;
          
begin
try
ww:=ComboBox1.Text;
ss:=SmartCardToolSetSERVER_ActiveX1.GetReaderInfo(ww);
if ss>''
   then begin
        info:=StringReplace(ss,'|',#13#10,[rfReplaceAll]);
        Memo.Lines.Add('');
        Memo.Lines.Add('ReaderInfo  '+tbl+ww);
        Memo.Lines.Add(info);
        end;
finally
end;
end;

procedure TMainForm.GetCardInfo_actExecute(Sender: TObject);
var       ww,ss:widestring;
          info:string;
          
begin
try
ww:=ComboBox1.Text;
ss:=SmartCardToolSetSERVER_ActiveX1.GetCardInfo(ww);
if ss>''
   then begin
        info:=StringReplace(ss,'|',#13#10,[rfReplaceAll]);
        Memo.Lines.Add('');
        Memo.Lines.Add('CardInfo    '+tbl+ww);
        Memo.Lines.Add(info);
        end;
finally
end;
end;

procedure TMainForm.GetCardTypeInfo_actExecute(Sender: TObject);
var       ww,atr,tn:widestring;
begin
try
ww:=ComboBox1.Text;
tn:=SmartCardToolSetSERVER_ActiveX1.GetCardTypeName(ww);
atr:=SmartCardToolSetSERVER_ActiveX1.GetCardATR(ww);
if atr>''
   then begin
        Memo.Lines.Add('');
        Memo.Lines.Add('CardTypeInfo '+tbl+ww);
        Memo.Lines.Add(dvd+tbl+'ATR        '+tbl+ATR);
        Memo.Lines.Add(dvd+tbl+'CardType   '+tbl+tn);
        end;
finally
end;
end;

procedure TMainForm.SendAPDU_actExecute(Sender: TObject);
var       ReaderName: WideString;
          Cla: WideString;
          Ins: WideString;
          P1: WideString;
          P2: WideString;
          P3Lc: WideString;
          Le: WideString;
          DataIn: WideString;
          CardReply: WideString;
begin
try
ReaderName:=ComboBox1.Text;
Cla:=Edit1.Text;
Ins:=Edit2.Text;
P1:=Edit3.Text;
P2:=Edit4.Text;
P3Lc:=Edit5.Text;
Le:=Edit6.Text;
DataIn:=Edit7.Text;
CardReply:=SmartCardToolSetSERVER_ActiveX1.SendAPDU(ReaderName,cla,ins,p1,p2,p3lc,le,datain);
if length(CardReply)>=4
   then begin
        Memo.Lines.Add('');
        Memo.Lines.Add('APDU         '+tbl+ReaderName);
        Memo.Lines.Add(dvd+tbl+Cla+' '+Ins+' '+P1+' '+P2+' '+P3Lc+' '+Le+' '+DataIn);
        Memo.Lines.Add(dvd+tbl+'Card reply  '+tbl+CardReply);
        end;

finally
end;
end;

procedure TMainForm.SendCOMMAND_actExecute(Sender: TObject);
var       ReaderName: WideString;
          Command: WideString;
          P1: WideString;
          P2: WideString;
          P3Lc: WideString;
          Le: WideString;
          DataIn: WideString;
          CardReply: WideString;
begin
try
ReaderName:=ComboBox1.Text;
Command:=Edit9.Text;
P1:=Edit8.Text;
P2:=Edit10.Text;
P3Lc:=Edit11.Text;
Le:=Edit12.Text;
DataIn:=Edit13.Text;
CardReply:=SmartCardToolSetSERVER_ActiveX1.SendCommand(ReaderName,Command,p1,p2,p3lc,le,datain);
if length(CardReply)>=4
   then begin
        Memo.Lines.Add('');
        Memo.Lines.Add('APDU         '+tbl+ReaderName);
        Memo.Lines.Add(dvd+tbl+'"'+Command+'" '+P1+' '+P2+' '+P3Lc+' '+Le+' '+DataIn);
        Memo.Lines.Add(dvd+tbl+'Card reply  '+tbl+CardReply);
        end;

finally
end;
end;

procedure TMainForm.ErrorLookup_actExecute(Sender: TObject);
var       v:integer;
          l:widestring;
begin
try
  try
  v:=StrToInt('$'+Edit14.Text);
  l:=SmartCardToolSetSERVER_ActiveX1.ErrorLookup(v,l);
  if l>''
     then begin
          Memo.Lines.Add('');
          Memo.Lines.Add('ErrorLookup');
          Memo.Lines.Add(dvd+tbl+'0x'+Edit14.Text+tbl+l);
          end;
  except  on em:exception do
          begin
          ShowMessage(em.message);
          end;
  end;
finally
end;
end;

procedure TMainForm.StateLookup_actExecute(Sender: TObject);
var       v:integer;
          l:widestring;
          
begin
try
  try
  v:=StrToInt('$'+Edit16.Text);
  l:=SmartCardToolSetSERVER_ActiveX1.StateLookup(v,l);
  if l>''
     then begin
          Memo.Lines.Add('');
          Memo.Lines.Add('StateLookup');
          Memo.Lines.Add(dvd+tbl+'0x'+Edit16.Text);
          l:=StringReplace(l,'|',#13#10,[rfReplaceAll]);
          Memo.Lines.Add(l);
          end;
  except  on em:exception do
          begin
          ShowMessage(em.message);
          end;
  end;
finally
end;
end;

procedure TMainForm.SWLookup_actExecute(Sender: TObject);
var       ReaderName: WideString;
          v,l:widestring;
          b1,b2:byte;

begin
try
  try
  v:=Edit15.Text;
  l:='';
  ReaderName:=ComboBox1.Text;
  l:=SmartCardToolSetSERVER_ActiveX1.SWLookup(ReaderName,b1,b2,v);
  if length(l)>=5
     then begin
          Memo.Lines.Add('');
          Memo.Lines.Add('SW Lookup   '+tbl+v);
          Memo.Lines.Add(dvd+tbl+l);
          end;
  except  on em:exception do
          begin
          ShowMessage(em.message);
          end;
  end;
finally
end;
end;

procedure TMainForm.COSLookup_actExecute(Sender: TObject);
var       ww,command,cla_hex,ins_hex:widestring;
          clains:widestring;
begin
try
ww:=ComboBox1.Text;
command:=Edit17.Text;
ClaIns:=SmartCardToolSetSERVER_ActiveX1.COSLookup(ww,command);
if ClaIns>''
   then begin
        cla_hex := copy(ClaIns,1,2);
        ins_hex := copy(ClaIns,4,2);
        Memo.Lines.Add('');
        Memo.Lines.Add('COS Command Lookup'+tbl+ww);
        Memo.Lines.Add(dvd+tbl+'command'+tbl+command);
        Memo.Lines.Add(dvd+tbl+'cla_hex'+tbl+cla_hex);
        Memo.Lines.Add(dvd+tbl+'ins_hex'+tbl+ins_hex);
        end;
finally
end;
end;

procedure TMainForm.GetReadersList_actExecute(Sender: TObject);
var       rl:widestring;
          rList:string;

begin
try
ComboBox1.Clear;
rl:=SmartCardToolSetSERVER_ActiveX1.GetReadersList;
if rl>''
   then begin
        rList:=StringReplace(rl,'|',#13#10,[rfReplaceAll]);
        ComboBox1.Items.Text:=rList;
        ComboBox1.ItemIndex:=0;
        end;
finally
end;
end;

procedure TMainForm.ShowApp_actUpdate(Sender: TObject);
begin
try
ShowApp_act.Enabled:=(Opened);
finally
end;
end;

procedure TMainForm.HideApp_actUpdate(Sender: TObject);
begin
try
HideApp_act.Enabled:=(Opened);
finally
end;
end;

procedure TMainForm.ConnectSCARD_actUpdate(Sender: TObject);
begin
try
ConnectSCARD_act.Enabled:=(not Connected);
finally
end;
end;

procedure TMainForm.DisconnectSCARD_actUpdate(Sender: TObject);
begin
try
DisconnectSCARD_act.Enabled:=(Connected);
finally
end;
end;

procedure TMainForm.GetReadersList_actUpdate(Sender: TObject);
begin
try
GetReadersList_act.Enabled:=(Opened) and (Connected);
finally
end;
end;

procedure TMainForm.Reopen_actUpdate(Sender: TObject);
begin
try
Reopen_act.Enabled:=(Opened) and (Connected);
finally
end;
end;

procedure TMainForm.GetReaderInfo_actUpdate(Sender: TObject);
begin
try
GetReaderInfo_act.Enabled:=(Opened) and (Connected);
finally
end;
end;

procedure TMainForm.GetCardInfo_actUpdate(Sender: TObject);
begin
try
GetCardInfo_act.Enabled:=(Opened) and (Connected);
finally
end;
end;

procedure TMainForm.GetCardTypeInfo_actUpdate(Sender: TObject);
begin
try
GetCardTypeInfo_act.Enabled:=(Opened) and (Connected);
finally
end;
end;

procedure TMainForm.SendAPDU_actUpdate(Sender: TObject);
begin
try
SendAPDU_act.Enabled:=(Opened) and (Connected);
finally
end;
end;

procedure TMainForm.SendCOMMAND_actUpdate(Sender: TObject);
begin
try
SendCOMMAND_act.Enabled:=(Opened) and (Connected);
finally
end;
end;

procedure TMainForm.ErrorLookup_actUpdate(Sender: TObject);
begin
try
ErrorLookup_act.Enabled:=(Opened);
finally
end;
end;

procedure TMainForm.StateLookup_actUpdate(Sender: TObject);
begin
try
StateLookup_act.Enabled:=(Opened);
finally
end;
end;

procedure TMainForm.SWLookup_actUpdate(Sender: TObject);
begin
try
SWLookup_act.Enabled:=(Opened) and (Connected);
finally
end;
end;

procedure TMainForm.COSLookup_actUpdate(Sender: TObject);
begin
try
COSLookup_act.Enabled:=(Opened) and (Connected);
finally
end;
end;

procedure TMainForm.SmartCardToolSetSERVER_ActiveX1APDU(Sender: TObject;
  var ReaderName: WideString; var SW1, SW2: Byte; var SW_HEX,
  VerboseSWLookup: WideString);
var   bSW1,bSW2:byte;
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('APDU          '+tbl+ReaderName);
bSW1:=SW1;
Memo.Lines.Add(dvd+tbl+'SW1        '+tbl+'0x'+IntToHex(bSW1,2));
bSW2:=SW2;
Memo.Lines.Add(dvd+tbl+'SW2        '+tbl+'0x'+IntToHex(bSW2,2));
Memo.Lines.Add(dvd+tbl+'SW_HEX     '+tbl+SW_HEX);
Memo.Lines.Add(dvd+tbl+'SWLookup   '+tbl+VerboseSWLookup);
finally
end;
end;


procedure TMainForm.SmartCardToolSetSERVER_ActiveX1BeforeConnectingSCARD(
  Sender: TObject);
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('---BeforeConnectingSCARD');
finally
end;
end;

procedure TMainForm.SmartCardToolSetSERVER_ActiveX1BeforeDisconnectingSCARD(
  Sender: TObject);
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('---BeforeDisconnectingSCARD');
finally
end;
end;

procedure TMainForm.SmartCardToolSetSERVER_ActiveX1BeforeReadersList(
  Sender: TObject);
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('---BeforeReadersList');
finally
end;
end;

procedure TMainForm.SmartCardToolSetSERVER_ActiveX1CardDetected(
  Sender: TObject; var ReaderName: WideString);
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('CardDetected   '+tbl+ReaderName);
finally
end;
end;

procedure TMainForm.SmartCardToolSetSERVER_ActiveX1CardReady(
  Sender: TObject; var ReaderName, ATR, Protocol: WideString);
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('CardReady     '+tbl+ReaderName);
Memo.Lines.Add(dvd+tbl+'ATR         '+tbl+ATR);
Memo.Lines.Add(dvd+tbl+'Protocol    '+tbl+Protocol);
finally
end;
end;

procedure TMainForm.SmartCardToolSetSERVER_ActiveX1CardType(
  Sender: TObject; var ReaderName, ATR, Protocol, TypeName: WideString);
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('CardType      '+tbl+ReaderName);
Memo.Lines.Add(dvd+tbl+'ATR         '+tbl+ATR);
Memo.Lines.Add(dvd+tbl+'Protocol    '+tbl+Protocol);
Memo.Lines.Add(dvd+tbl+'TypeName    '+tbl+TypeName);
finally
end;
end;

procedure TMainForm.SmartCardToolSetSERVER_ActiveX1CardWait(
  Sender: TObject; var ReaderName: WideString);
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('CardWait       '+tbl+ReaderName);
finally
end;
end;

procedure TMainForm.SmartCardToolSetSERVER_ActiveX1ConnectedSCARD(
  Sender: TObject);
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('ConnectedSCARD ');
Connected:=true;
finally
end;

end;

procedure TMainForm.SmartCardToolSetSERVER_ActiveX1DisconnectedSCARD(
  Sender: TObject);
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('DisconnectedSCARD');
Connected:=false;
ComboBox1.Clear;
finally
end;
end;

procedure TMainForm.SmartCardToolSetSERVER_ActiveX1ReadersList(
  Sender: TObject; var ReadersNames: WideString);
var       ss:string;
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('ReadersList    '+tbl+ReadersNames);
ss:=StringReplace(ReadersNames,'|',#13#10,[rfReplaceAll]);
ComboBox1.Items.Text:=ss;
ComboBox1.ItemIndex:=0;
finally
end;
end;

procedure TMainForm.SmartCardToolSetSERVER_ActiveX1StateChanged(
  Sender: TObject; var ReaderName, StateHex,
  VerboseStateLookup: WideString; var StateValue: Integer);
var           ii:integer;
begin
try
ii:=StateValue;
Memo.Lines.Add('');
Memo.Lines.Add('StateChanged: '+tbl+'0x'+IntToHex(ii,8));
Memo.Lines.Add(dvd+tbl+'ReaderName  '+tbl+ReaderName);
Memo.Lines.Add(dvd+tbl+'StateHex    '+tbl+StateHex);
Memo.Lines.Add(dvd+tbl+'StateLookup '+tbl+VerboseStateLookup);
finally
end;
end;

procedure TMainForm.SmartCardToolSetSERVER_ActiveX1_ERROR(Sender: TObject;
  var ErrorSource: WideString; var ErrorValue: Integer;
  var VerboseErrorLookup: WideString);
var   ii:integer;
begin
try
ii:=ErrorValue;
Memo.Lines.Add('');
Memo.Lines.Add('*** ERROR ************************');
Memo.Lines.Add(dvd+tbl+'ErrorSource'+tbl+ErrorSource);
Memo.Lines.Add(dvd+tbl+'ErrorValue'+tbl+'0x'+IntToHex(ii,8));
Memo.Lines.Add(dvd+tbl+'ErrorLookup'+tbl+VerboseErrorLookup);
finally
end;
end;

procedure TMainForm.SmartCardToolSetSERVER_ActiveX1_ServerApplicationClosed(
  Sender: TObject);
begin
try
finally
Connected:=false;
Opened:=false;
end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
try
  try
  DisconnectSCARD_act.Execute;
  except  on em:exception do
          begin
          ShowMessage(em.message);
          end;
  end;
finally
end;
end;

procedure TMainForm.PropSet_actUpdate(Sender: TObject);
begin
try
PropSet_act.Enabled:=(Opened);
finally
end;
end;

procedure TMainForm.PropSet_actExecute(Sender: TObject);
var       ss,pp:widestring;
begin
try
  try
  ss:=MemoPref.Lines.Text;
  ss:=StringReplace(ss,#13#10,'|',[rfReplaceAll]);
  pp:=SmartCardToolSetSERVER_ActiveX1.SetPreferencesParam(ss);
  ss:=StringReplace(pp,'|',#13#10,[rfReplaceAll]);
  MemoPrefRes.Text:=ss;
  except  on em:exception do
          begin
          ShowMessage(em.message);
          end;
  end;
finally
end;
end;

end.

